#ifndef CAREGIPROCESS_H
#define CAREGIPROCESS_H

#include <cuthreadlistener.h>
#include <cutimerlistener.h>
#include <list>

class CaReceiverData;
class CuLog;
class CaProxyPPrivate;
class Cumbia;
class CaRegistrar;
class CaProxyThreadPool;
class CuData;
class CaHttpMsg;

class CaProxyProcess : public CuThreadListener, public CuTimerListener
{
public:

    CaProxyProcess(Cumbia* cumbia,
                   const CuData& opts,
                   CuLog *log,
                   const std::string& servaddr,
                   const unsigned short servport,
                   const CaRegistrar *registrar,
                   const CaProxyThreadPool *thp);
    virtual ~CaProxyProcess();

    std::string error() const;

    // CuThreadListener interface
public:
    void onProgress(int step, int total, const CuData &data);
    void onResult(const CuData &data);
    void onResult(const std::vector<CuData> &datalist);
    void onResult(const CuUserData *rd);


    CuData getToken() const;
    // CuTimerListener interface
    void onTimeout(CuTimer *);

private:
    bool m_data_redistrib(int fd, const CaHttpMsg *nmsg);
    bool m_token_event(const unsigned long long& tok,
                       const std::string& addr,
                       const int fd,
                       bool unsub);
    inline int m_set_expcheck_interval(const CuData &opts) const;

    CaProxyPPrivate *d;
};

#endif // CAREGIPROCESS_H
