#ifndef CaProxyJsonH_H
#define CaProxyJsonH_H

#include <string>
#include <vector>

#include "caproxy.h"

class CaProxyJsonH
{
public:
    CaProxyJsonH();
    bool divide(const std::string& rin,
                std::string& syreq,
                std::string& asyreq, std::string &async_unsubscribe, unsigned long long *id,
                std::string &error_msg, long srv_id) const;
    std::string merge(const std::string_view &syr, const std::string_view &asyr, const std::string_view &asyur, std::string &error_msg) const;
    unsigned long long tokmsg_process(const std::string& s, bool *unsub, std::string &error_msg);
    std::string make_unsubscribe(const std::vector<unsigned long long> &ids) const;
    std::string make_up2date(const std::vector<unsigned long long> &ids) const;
    std::string make_err(const std::string& msg) const;
    bool is_err(const std::string& json) const;
    bool json_reply_ok(const std::string_view &json) const;
    bool is_subscribe_req(const std::string& json) const;
//    bool insert_srvid_evtyp(const std::string& in, long srv_id, std::string& out, CaProxyEvent::CaProxyEventType ty) const;
    bool srcs_match(const std::string &jout, const std::string &jin, int *nsrcout, int *nsrcin) const;
};

#endif // CaProxyJsonH_H
