#include "caproxylistener.h"
#include "caproxythreadpool.h"
#include <cajson-data-encoder.h>
#include <calog.h>
#include "caproxyhttph.h"

class CaProxyListenerP {
public:
    CaProxyListenerP() : propool(nullptr), log(nullptr) {}

    CaProxyThreadPool* propool;
    CuLogImplI *log;
    CaProxyHttpH phttph;
};

CaProxyListener::CaProxyListener() {
    d = new CaProxyListenerP;
}

CaProxyListener::~CaProxyListener() {
    printf("~CaProxyListener %p\n", this);
    delete d;
}

void CaProxyListener::init(CaProxyThreadPool *pp, CuLogImplI *log) {
    d->propool = pp;
    d->log = log;
}

void CaProxyListener::onProgress(int step, int total, const CuData &data) { }

void CaProxyListener::onResult(const CuData &data) {
    const int& cli_fd = data.i("fd");
    if(data.b("err") && cli_fd > 0 && data.I("code") == CaProxy::CaPSoOk)
        d->propool->msg_send_cli(cli_fd, CaProxyEvent::CaPHttp503, CaJsonDataEnc().toString(std::list<CuData> {data.remove("fd")} ));
    printf("CaProxyListener.onResult \e[1;36m%s\e[0m\n", datos(data));
}

void CaProxyListener::onResult(const std::vector<CuData> &datalist) { }

CuData CaProxyListener::getToken() const {
    return CuData("type", "ca-proxy-listener");
}
