#ifndef CAPROXYTHREADPOOL_H
#define CAPROXYTHREADPOOL_H

#include <caproxy.h> // for CaProxy::CaserverType

class CaProxyThreadPoolPrivate;
class Cumbia;
class CuThreadListener;
class CaReceiver_A;

class CaProxyThreadPool
{
public:
    CaProxyThreadPool(Cumbia* cumbia,
                      CaReceiver_A *rec,
                      CuThreadListener *thl,
                      const CuData& opts,
                      const std::string& servaddr,
                      const unsigned short servport,
                      int poolsiz);
    virtual ~CaProxyThreadPool();

    void stop();
    void do_proxy(int fd,
                  CaProxyEvent::CaPHttpMsgType msgt,
                  const std::string& syr,
                  const std::string& s_asyr,
                  const std::string& u_asyr,
                  const std::string& httphdr,
                  unsigned long clen_orig) const;

    void msg_send_caserver(const CaProxyRoute &pr,
                           CaProxyEvent::CaPHttpMsgType msgt,
                           const std::string& http_payl,
                           CaProxyEvent::CaProxyEventType ety) const;

    void msg_send_cli(int to,
                      CaProxyEvent::CaPHttpMsgType msgt,
                      const std::string& payload) const;

    void fd_state_change(int fd, bool open) const;
    void set_srv_id(long int srv_id);

    std::string server_addr() const;
    unsigned short server_port() const;
    long int srv_id() const;

private:
    CaProxyThreadPoolPrivate *d;
    CaProxy* m_pick_proxy() const;
};

#endif // CAPROXYTHREADPOOL_H
