#include "caregidbmon.h"
#include <cumacros.h>
#include "cadbhandle.h"
#include "calog.h"

#include <sstream>
#include <locale>
#include <iomanip>
#include <chrono>

class CaRegiDbMonPrivate {
public:
    CaDbH *dbh;
    std::string msg;
    bool error;
    int superv_id;
    CuLogImplI *log;
};

CaRegiDbMon::CaRegiDbMon(const CuData &tok, CuLogImplI* log) : CuPeriodicActivity(tok) {
	d = new CaRegiDbMonPrivate;
    d->log = log;
    d->superv_id = -1;
}

CaRegiDbMon::~CaRegiDbMon() {
    delete d;
}

bool CaRegiDbMon::matches(const CuData &token) const {
	printf("CaRegiDbMon.matches token %s matches my tok %s?\n", datos(token), datos(getToken()));
    return getToken()["type"] == token["type"];
}

void CaRegiDbMon::init()
{
    if(getToken().containsKey("mon_interval"))
        setInterval(getToken()["mon_interval"].toInt() * 1000);
    else
        setInterval(CLI_TTL * 1000);
    const CuData&tok = getToken();
    d->dbh = new CaDbH(tok["dbu"].toString(), tok["dbp"].toString(), tok["dbna"].toString(), tok["dbh"].toString());
    d->error = !d->dbh->connect();
    if(!d->error) {
    }
    publishResult(CuData("type", "init").set("err", d->error).set("msg", d->dbh->msg));
}

void CaRegiDbMon::execute() {
	printf(" [0x%lx ] CaRegiDbMon.execute enter\n", pthread_self());
    if(!d->error) {


    }
}

void CaRegiDbMon::onExit() {

}

void CaRegiDbMon::event(CuActivityEvent *e) {
//    printf(" [0x%lx ] CaRegiDbMon.event enter\n", pthread_self());
//    if(e->getType() == (int) CaRegiRecoverXmitEvent::RecoverXmitEventType) {
//        CaRegiRecoverXmitEvent *xe = static_cast<CaRegiRecoverXmitEvent *>(e);
//        CaRegiDbFuncs dbf;
//        dbf.set_last_recover_successful(d->dbh, xe->success);
//    }
//    else
        CuPeriodicActivity::event(e);
//    printf(" [0x%lx ] CaRegiDbMon.event exit\n", pthread_self());
}

