#ifndef CAUNSUBMULTICAST_H
#define CAUNSUBMULTICAST_H

#include <thread>
#include <string>

class CuData;
class CaUnsubThreadPrivate;
class CaUnsubMulticastPrivate;


class CaUnsubThread {
public:
    CaUnsubThread(const std::string& addr, const std::string & port);
    ~CaUnsubThread();
    void setBuf(const std::string& bu);
    std::string reply() const;
    void start();

    std::string host() const;
    std::string port() const;
    std::string errmsg() const;

    void wait();

protected:
    void run();

private:
    CaUnsubThreadPrivate *d;
    int m_connect(const char *addr, const char *port);
    int m_sock_read(int sofd, std::string &in);
    int m_sock_write(int sofd, const char *buf);
};


class CaUnsubMulticast
{
public:
    CaUnsubMulticast(const CuData& opts);
    ~CaUnsubMulticast();
    int send_multi(const std::string& in, std::string& reply);

    bool json_reply_merge(const std::string_view &jin, std::string &jout, const std::string &h, const std::string &p, bool ok) const;

private:
    CaUnsubMulticastPrivate *d;
};

#endif // CAUNSUBMULTICAST_H
